#include "const.h"
#include "rotinas.h"
#include "winged.h"

extern Points Pontos[Pmax], PDesenha[Pmax];
extern int numPontos;
int WindowHeight,WindowWidth;
int NumComp = 0;

void Graham_ScanModoGrafico(Pilha *P);
void Graham_Scan();


/* Funcao que retorna o ponto p0 em Pontos[numPontos] com a menor y-coordenada; */
/* Em caso de empate, o ponto mais a direita sera devolvido. */
Points Primeiro_PontoExtremo()
{
  int i;
  Points aux;
  
  aux = Pontos[0];
  for(i=1; i<numPontos; i++)
    {
      NumComp++;
      if (Pontos[i].coord[Y] < aux.coord[Y])
	aux = Pontos[i];
      else 
	{
	  if (Pontos[i].coord[Y] == aux.coord[Y])
	    if(Pontos[i].coord[X] > aux.coord[X])
	    aux = Pontos[i];
	}
    }
  return (aux);
}


/* Funcao que devolve p1,p2,...,pn-1 pontos de Pontos[Pmax]/p0 ordenados em */
/* relacao ao angulo polar que estes pontos formam ao redor do ponto p0. Se */
/* mais de um ponto tem o mesmo angulo, descartar todos menos o que esta mais */
/* distante de p0. */
void OrdenaPontos(Points p)
{
  // p e' o ponto inicial ( coordenada y mais baixa )
  
  int i = 0,j,achou=0;
  Points aux;
  
  while(!achou)
    {
      NumComp++;
      if(Pontos[i].coord[X] == p.coord[X] && Pontos[i].coord[Y] == p.coord[Y])
	achou = 1;
      else
	i++;
    }
  aux = Pontos[numPontos-1];
  Pontos[numPontos-1] = Pontos[i];
  Pontos[i] = aux;
  
  printf("\nUltima pos = %f %f\n", Pontos[numPontos-1].coord[X],Pontos[numPontos-1].coord[Y]);
  
  for(i = 0; i < numPontos-1; i++)
    {
	  for(j = i+1; j < numPontos-1; j++)
	    {
	      NumComp++;
	      if ( ! Left(p,Pontos[i],Pontos[j]) )
		{
		  aux = Pontos[i];
		  Pontos[i] = Pontos[j];
		  Pontos[j] = aux;
		}
	    }
    }
  for(i = 0;i<numPontos-1;i++)
    printf("Ponto[%d].coord[X] = %f ; Ponto[%d].coord[Y] = %f \n",i,Pontos[i].coord[X],i,Pontos[i].coord[Y]);
}


/* Algoritmo que calcula o fecho convexo dos pontos em Pontos[numPontos]. */
void Graham_Scan()
{
  Points p0,Pt,Pt1;
  int i;

  p0 = Primeiro_PontoExtremo();
  
  OrdenaPontos(p0);
  
  CriaPilha();
  
  Empilha(p0);
  Empilha(Pontos[0]);
  Empilha(Pontos[1]);
  
  i = 2;
  while(i < numPontos-1)
    {
      Pt = Topo();
      Pt1 = Topo1();
      NumComp++;
      if( Left(Pt1,Pt,Pontos[i]) )
	{
	  
	  Empilha(Pontos[i]);
	  i++;
	}
      else
	Desempilha();
  }
  /*i=0;
   while(!PilhaVazia(P))
    {
      Pt = Desempilha(P);
      Pontos[i] = Pt;
      i++;
      printf("%f, %f \n",Pt.coord[X],Pt.coord[Y]);
    }
  Pontos[i] = p0;
  numPontos = i;*/
}


Points p0,Pt,Pt1;
int i;

void InitGraham()
{
  p0 = Primeiro_PontoExtremo();
  
  OrdenaPontos(p0);
  
  CriaPilha();
  
  Empilha(p0);
  Empilha(Pontos[0]);
  Empilha(Pontos[1]);
  
  i = 2;
}

void Passo()
{
  if(i < numPontos-1)
  {
    Pt = Topo();
    Pt1 = Topo1();
    
    NumComp++;
    if( Left(Pt1,Pt,Pontos[i]) )
    {
      Empilha(Pontos[i]);
      i++;
    }
    else
      Desempilha();
  }
}

int Bool = 0;

int main(int argc, char **argv)
{
  P = malloc(sizeof(Pilha));
  
  LeArquivo(argv);

  InicializaModoGrafico(&argc,argv);
  CriaJanela(WindowHeight,WindowWidth,"Graham Scan");

  glutReshapeFunc(Reshape);
  glutKeyboardFunc(Keyboard);
  glutPassiveMotionFunc(MouseMotion);
  glutDisplayFunc(display);

  if(argv[2][0] == '1')
  {
    Bool = 1;
    InitGraham();
  }

  else
  {
    printf("\nModo normal\n");
    Graham_Scan();
  }

  glutMainLoop();
  return 0;
}
