#include "const.h" 
#include "rotinas.h"

extern int WindowHeight,WindowWidth;
extern Points Pontos[Pmax], PEntrada[Pmax];
extern Arestas Aresta[Pmax-1];
int NextPressed = 0;
int nAresta = 0;
int WaitTime = 100;
extern int NumComp;

/* Estrutura arquivo de entrada */
/* linha 1: numero de pontos
   linha 2 em diante: X Y */
void LeArquivo(char **argv)
{
  int i;
  FILE *in;

  in = fopen(argv[1], "r");
  printf("\narquivo -> %s\n",argv[1]);
  fscanf(in,"%d\n",&numPontosEntrada);
  printf("Numero de pontos: %d\n", numPontosEntrada);
  for(i=0;i<numPontosEntrada;i++)
    fscanf(in,"%f %f\n",&PEntrada[i].coord[X],&PEntrada[i].coord[Y]);
  fclose(in);

  printf("Coordenadas:\n");
  for(i=0;i<numPontosEntrada;i++)
    {
      printf("    %f %f\n",PEntrada[i].coord[X],PEntrada[i].coord[Y]);
      Pontos[i].coord[X] = PEntrada[i].coord[X];
      Pontos[i].coord[Y] = PEntrada[i].coord[Y];
    }
  numPontos = numPontosEntrada;
}


float Area2(Points a, Points b, Points c)
{
  float result;
  
  result = (a.coord[X]*b.coord[Y]) - (a.coord[Y]*b.coord[X]) + (a.coord[Y]*c.coord[X]) - (a.coord[X]*c.coord[Y]) + (b.coord[X]*c.coord[Y]) -  (c.coord[X]*b.coord[Y]);
  return(result);
}

int Left(Points a, Points b, Points c)
{
  if ( Area2(a,b,c) > 0 )
    return (1);
  return (0);
}

int LeftOn(Points a, Points b, Points c)
{
  if ( Area2(a,b,c) >= 0 )
    return (1);
  return (0);
}


/***** Rotinas p/ manipulacao de modo grafico *****/
float GetMaxX()
{
  float aux;
  int i;
  aux = -10000;

  for(i = 0; i < numPontos;i++)
    {
      if (Pontos[i].coord[X] > aux)
	aux = Pontos[i].coord[X];
    }
  return aux;
}

float GetMaxY()
{
  float aux;
  int i;
  aux = -10000;

  for(i = 0; i < numPontos;i++)
    {
      if (Pontos[i].coord[Y] > aux)
	aux = Pontos[i].coord[Y];
    }
  return aux;
}

float GetMinX()
{
  float aux;
  int i;
  aux = 10000;

  for(i = 0; i < numPontos;i++)
    {
      if (Pontos[i].coord[X] < aux)
	aux = Pontos[i].coord[X];
    }
  return aux;
}

float GetMinY()
{
  float aux;
  int i;
  aux = 10000;

  for(i = 0; i < numPontos;i++)
    {
      if (Pontos[i].coord[Y] < aux)
	aux = Pontos[i].coord[Y];
    }
  return aux;
}


void MostraPontos()
{
  int i;
  
  for(i = 0;i<numPontosEntrada;i++)
    glRectf(PEntrada[i].coord[X]-.1,PEntrada[i].coord[Y]-.1,PEntrada[i].coord[X]+.1,PEntrada[i].coord[Y]+.1);
}


void InicializaModoGrafico(int *argc,char **argv)
{
  glutInit(argc,argv);
  glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE );
  WindowHeight = WindowWidth = 400;
}

void CriaJanela(int w, int h, char *name)
{
  glutInitWindowSize(w,h); 
  glutCreateWindow(name);
  glutInitWindowPosition(MAX_SCREEN_WIDTH/4,MAX_SCREEN_HEIGTH/3);
}

/* Callback chamada toda vez que a janela muda de tamanho real */
void Reshape(int width, int height)
{
  float MaxX,MaxY,MinX,MinY;
  float Ratio;
  WindowWidth = width;
  WindowHeight = height;
  glViewport (0, 0, (GLsizei) width, (GLsizei) height); 
  //  glViewport(0,0,width,height);

  MaxX = GetMaxX();
  MaxY = GetMaxY();
  MinX = GetMinX();
  MinY = GetMinY();
  Ratio = MaxX/(MaxX-MinX);
  
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(MinX - Ratio,MaxX + Ratio,MinY - Ratio,MaxY + Ratio);
  
  glClearColor(0.0,0.0,0.0,1.0);
  glClear(GL_COLOR_BUFFER_BIT);
  //  gluPerspective(FrustrumFOV,FrustrumASPECT,FrustrumNEAR,FrustrumFAR);
  //  gluPerspective(60.0, (GLfloat) width/(GLfloat) height, 1.0, 20.0);
}


extern int Bool;

void display()
{
    int i;

    glClearColor(0.0,0.0,0.0,1.0);
    glClear(GL_COLOR_BUFFER_BIT);

    //glMatrixMode(GL_MODELVIEW);
    //glLoadIdentuty();

    glColor3f(0.0,0.0,1.0);
    MostraPontos();

    glColor3f(1.0,0.0,0.0);
    glBegin(GL_LINE_STRIP);
    for(i = 0;i <= P->topo ;i++)
      glVertex2f(P->cell[i].coord[X],P->cell[i].coord[Y]);
    glVertex2f(P->cell[0].coord[X],P->cell[0].coord[Y]);
    glEnd();

  glutSwapBuffers();
}

void display2()
{
  int Teste = 1;
  int i,j,k;
  glClearColor(0.0,0.0,0.0,1.0);
  glClear(GL_COLOR_BUFFER_BIT);
  
    //glMatrixMode(GL_MODELVIEW);
    //glLoadIdentuty();

    glColor3f(0.0,0.0,1.0);
    MostraPontos();
    

    /*glColor3f(0.0,1.0,0.0);
    glBegin(GL_LINE);
    glVertex2f(PEntrada[i].coord[X],PEntrada[i].coord[Y]);
    glVertex2f(PEntrada[j].coord[X],PEntrada[j].coord[Y]);
    glEnd();
    glFlush();*/
    for(i=0;i<numPontosEntrada;i++)
      for(j=0;j<numPontosEntrada;j++)
	if(j!=i)
	  {
	    glColor3f(1.0,0.0,0.0);
	    glRectf(PEntrada[i].coord[X]-.1,PEntrada[i].coord[Y]-.1,PEntrada[i].coord[X]+.1,PEntrada[i].coord[Y]+.1);
	    glColor3f(1.0,0.0,0.0);
	    glRectf(PEntrada[j].coord[X]-.1,PEntrada[j].coord[Y]-.1,PEntrada[j].coord[X]+.1,PEntrada[j].coord[Y]+.1);
	    glColor3f(0.0,1.0,0.0);
	    glBegin(GL_LINE_STRIP);
	    glVertex2f(PEntrada[i].coord[X],PEntrada[i].coord[Y]);
	    glVertex2f(PEntrada[j].coord[X],PEntrada[j].coord[Y]);
	    glEnd();
	    glFlush();
	    glutSwapBuffers();
	    for(k=0;k<numPontosEntrada;k++)
	      {
		if(k!=i && k!=j)
		  {
		    glColor3f(0.0,1.0,1.0);
		    glRectf(PEntrada[k].coord[X]-.1,PEntrada[k].coord[Y]-.1,PEntrada[k].coord[X]+.1,PEntrada[k].coord[Y]+.1);
		    glFlush();
		    glutSwapBuffers();
		    NumComp++;
		    if(!Left(PEntrada[i],PEntrada[j],PEntrada[k]))
		      {
			Teste = 0;
		      }
		  }
		usleep(WaitTime);
		glColor3f(0.0,0.0,1.0);
		glRectf(PEntrada[k].coord[X]-.1,PEntrada[k].coord[Y]-.1,PEntrada[k].coord[X]+.1,PEntrada[k].coord[Y]+.1);
		glFlush();
		glutSwapBuffers();
	      }
	    	    
	    glColor3f(0.0,0.0,1.0);
	    glRectf(PEntrada[i].coord[X]-.1,PEntrada[i].coord[Y]-.1,PEntrada[i].coord[X]+.1,PEntrada[i].coord[Y]+.1);
	    glColor3f(0.0,0.0,1.0);
	    glRectf(PEntrada[j].coord[X]-.1,PEntrada[j].coord[Y]-.1,PEntrada[j].coord[X]+.1,PEntrada[j].coord[Y]+.1);
	    if (Teste && i!=k && j!=k)
	      {
		glColor3f(1.0,1.0,1.0);
		glBegin(GL_LINE_STRIP);
		glVertex2f(PEntrada[i].coord[X],PEntrada[i].coord[Y]);
		glVertex2f(PEntrada[j].coord[X],PEntrada[j].coord[Y]);
		glEnd();
		glFlush();
		glutSwapBuffers();
		Aresta[nAresta].u = PEntrada[i];
		Aresta[nAresta].v = PEntrada[j];
		nAresta++;
	      }
	    else
	      Teste = 1;
	  }

    glColor3f(0.0,1.0,1.0);
    for(i=0;i<nAresta;i++)
      {
	glBegin(GL_LINE_STRIP);	
	glVertex2f(Aresta[i].u.coord[X],Aresta[i].u.coord[Y]);
	glVertex2f(Aresta[i].v.coord[X],Aresta[i].v.coord[Y]);
	glEnd();
      }
    glutSwapBuffers();
    printf("\n\nNumero de Comparacoes: %d\n", NumComp);
}



void Keyboard(unsigned char key, int x, int y)
{
  key = tolower(key);
  switch (key)
    {
    case 'q': /* encerra o programa */
      exit(0);
      break;
    }
  display();
}




void MouseMotion(int x, int y)
{
  //  display2();
}


/***** Rotinas de Pilha *****/
int PilhaVazia()
{
  return(P->topo == -1);
}

void CriaPilha()
{
  P->topo = -1;
}

void Empilha(Points x)
{
  (P->topo)++;
  P->cell[P->topo] = x;
}

Points Desempilha()
{
  Points aux;
  
  aux = P->cell[P->topo];
  (P->topo)--;
  return(aux);
}

Points Topo()
{
  return(P->cell[P->topo]);
}

Points Topo1()
{
  return(P->cell[P->topo-1]);
}



