#include <malloc.h>
#include "const.h"
#include "winged.h"

aresta *constroi_aresta(vertice *p0, vertice *p1)
{
  aresta *a = malloc(sizeof(aresta));

  a->livre = 42;

  a->v1 = p0;
  a->v2 = p1;

  a->fccw = a->fcw = NULL;
  a->pccw = a->nccw = a->pcw = a->ncw = NULL;

  if(p1->av == NULL)
    p1->av = a;

  return a;
}

vertice *constroi_vertice(int x, int y, int z)
{
  vertice *v = malloc(sizeof(vertice));

  v->coord[X] = x;
  v->coord[Y] = y;
  v->coord[Z] = z;

  v->av = NULL;

  return v;
}

face *constroi_face(vertice *p0, vertice *p1, vertice *p2)
{
  aresta *a1, *a2, *a3;
  face *f;

  a1 = constroi_aresta(p0, p1);
  a2 = constroi_aresta(p1, p2);
  a3 = constroi_aresta(p2, p0);

  f = malloc(sizeof(face));

  f->af = a1;

  a1->fcw = f;
  a2->fcw = f;
  a3->fcw = f;

  a1->pcw = a2; a1->ncw = a3;
  a2->pcw = a3; a2->ncw = a1;
  a3->pcw = a1; a3->ncw = a2;

  return f;
}

face *face_com_aresta(aresta *a1, vertice *v)
{
  aresta *a2, *a3;
  face *f = malloc(sizeof(face));

  a2 = constroi_aresta(a1->v2, v);
  a3 = constroi_aresta(v, a1->v1);

  f->af = a1;

  if(a1->fccw == NULL)
  {
    a1->fccw = f;
    a2->fccw = f;
    a3->fccw = f;

    a1->nccw = a2; a1->pccw = a3;
    a2->nccw = a3; a2->pccw = a1;
    a3->nccw = a1; a3->pccw = a2;
  }
  else
  {
    a1->fcw = f;
    a2->fcw = f;
    a3->fcw = f;

    a1->pcw = a2; a1->ncw = a3;
    a2->pcw = a3; a2->ncw = a1;
    a3->pcw = a1; a3->ncw = a2;
  }

  return f;
}

aresta *primeira_aresta(face *f)
{
  return f->af;
}

aresta *proxima_aresta(aresta *a, face *f)
{
  if(a->fccw == f)
    return a->nccw;
  else if(a->fcw == f)
    return a->ncw;
  else
    return NULL;
}

// Que nao essa
aresta *proxima_aresta_livre(aresta *a, face *f)
{
  aresta *tmp;

  if(a->fccw == f)
  {
    for(tmp = a->nccw; tmp != a && tmp->livre == 0; tmp = tmp->nccw);
    if(tmp == a)
      return NULL;
  }
  else
  {
    if(a->fcw != f)
      return NULL;

    for(tmp = a->ncw; tmp != a && tmp->livre == 0; tmp = tmp->ncw);
    if(tmp == a)
      return NULL;
  }

  return tmp;
}

fila *inicializa_fila(face *f)
{
  celula *c = malloc(sizeof(celula));
  fila *q = malloc(sizeof(fila));

  c->f = f;
  c->prox = NULL;
  c->ant = NULL;

  q->inicio = q->fim = c;

  return q;
}

void poe_fila(fila *q, face *f)
{
  celula *c = malloc(sizeof(celula));

  c->f = f;
  c->prox = q->fim;
  c->prox->ant = c;
  c->ant = NULL;

  q->fim = c;
}

face *tira_fila(fila *q)
{
  celula *c = q->inicio;
  face *f = c->f;

  c->ant->prox = NULL;
  q->inicio = c->ant;

  free(c);

  return f;
}

int fila_fazia(fila *q)
{
  return q->inicio == NULL;
}

    

