#ifndef WINGED_H
#define WINGED_H 42


typedef struct aresta_st
{
  struct vertice_st *v1, *v2;
  struct face_st *fccw, *fcw;
  struct aresta_st *pccw, *nccw, *pcw, *ncw;

  int livre;
} aresta;

typedef struct vertice_st
{
  int coord[3];

  struct aresta_st *av;
} vertice;

typedef struct face_st
{
  struct aresta_st *af;
} face;

aresta *constroi_aresta(vertice *p0, vertice *p1);

vertice *constroivertice(int x, int y, int z);

face *constroi_face(vertice *p0, vertice *p1, vertice *p2);

face *face_com_aresta(aresta *a, vertice *v);

aresta *primeira_aresta(face *f);

aresta *proxima_aresta(aresta *a, face *f);

aresta *proxima_aresta_livre(aresta *a, face *f);

// Funcoes da Fila
typedef struct celula_st
{
  face *f;
  struct celula_st *prox;
  struct celula_st *ant;
} celula;

typedef struct fila_st
{
  celula *inicio;
  celula *fim;
} fila;

fila *inicializa_fila(face *f);

void poe_fila(fila *q, face *f);

face *tira_fila(fila *q);

int fila_fazia(fila *q);

#endif






